unit N2R;

interface

procedure num_to_rub(f : Double; aCopecks, aRubles, aPowers : Longint; P : PChar); stdcall; export;
{
     
:
    f - .   - .  - 
    aCopecks -   
        0 -  ('')
        1 -   ('  .')
        2 -   ('  ','  '  ..)
        1 -    ('21 .')
        2 -    ('21 ','25 '  ..)
    aRubles -   
        0 -  ('')
        1 -   (' .')
        2 -   (' ',' '  ..)
    aPowers -   
        1 -   (' .',' .',' .',' .')
        2 -   (' ',' ',''  ..)
    P -      .    
          ( 1000 )
:
num_to_rub(1234578.90, 2, 2, 2, P)    P :
'         
 '

Object Pascal  Double, Longint, PChar 
/C++  double, long,  char* .
stdcall  _stdcall
}

implementation

uses SysUtils;
type
  Gender = (Masculine, Feminine);
  Power = (Copecks, Rubles, Thousands, Millions, Billions, Trillions);
  Num2StringArray = array[1..4,1..9] of String;
const
  N2S : Num2StringArray =
  (
   ('','','','','',
    '','','',''), {[1,x]}
   ('','','','','',
    '','','',''),{[2,x]}
   ('','','','','',
    '','','',''), {[3,x]}
   ('','','','','',
    '','','','')   {[4,x]}
  );

function digit_to_char(digit : Byte) : AnsiChar;
begin
     Result := Char(Ord('0') + digit);
end;

function char_to_digit(ch : AnsiChar) : Byte;
begin
     Result := Ord(ch) - Ord('0');
end;

procedure split_triada(triada : Word; var digit1, digit2, digit3 : Byte);
begin
 digit1 := triada mod 10;
 triada := triada div 10;
 digit2 := triada mod 10;
 triada := triada div 10;
 digit3 := triada mod 10;
end;

function digit_to_str(digit : Byte; aGender: Gender):String;
begin
   case digit of
        1 :
          if aGender = Masculine then Result:=N2S[1, digit] + ''
          else Result := N2S[1, digit] + '';
        2 :
          if aGender = Masculine then Result:=N2S[1, digit] + ''
          else Result := N2S[1, digit] + '';
        0, 3..9 :
           Result := N2S[1, digit];
        else
           // What to do?
           Result := '';
   end
end;

function decoded_diada_to_str(digit1, digit2 : Byte; aGender : Gender; ignoreZero : Boolean):String;
begin
  if((digit2 = 0) and (digit1 = 0)) then begin
     if ignoreZero then
        Result := ''
     else
         Result := '';
  end else if digit2 = 0 then Result := digit_to_str(digit1, aGender)
  else if digit1 = 0  then Result := N2S[3, digit2]
  else if digit2 = 1 then Result := N2S[2, digit1]
  else Result := N2S[3, digit2] + ' ' + digit_to_str(digit1, aGender);
end;

function triada_to_str(triada : Word; aGender : Gender):String;
var digit1, digit2, digit3 : Byte;
    tmp : String;
begin
  split_triada(triada, digit1, digit2, digit3);
  if digit3 > 0 then begin
     tmp := decoded_diada_to_str(digit1, digit2, aGender, true);
     if Length(tmp) > 0 then
        Result := N2S[4, digit3] + ' ' + tmp
     else
        Result := N2S[4, digit3];
  end else Result := decoded_diada_to_str(digit1, digit2, aGender, false);
end;

procedure split_sum(sum : Double;
          var wCop, wRubles, wThousands, wMillions, wBillions, wTrillions : Word);
          var tmp : Double;
          var s : String;
          var isum : Longint;
begin
     wThousands := 0;
     wMillions := 0;
     wBillions := 0;
     wTrillions := 0;
     wCop := round(Frac(sum) * 100);
{     if wCop mod 10 >= 5 then
        wCop := wCop div 10 + 1
     else
        wCop := wCop div 10;}
     try
        isum := Trunc(sum);
        wRubles := isum mod 1000;
        isum := isum div 1000;
        if isum > 0 then begin
           wThousands := isum mod 1000;
           isum := isum div 1000;
           if isum > 0 then begin
              wMillions := isum mod 1000;
              isum := isum div 1000;
              if isum > 0 then begin
                 wBillions := isum mod 1000;
                 isum := isum div 1000;
                 if isum > 0 then begin
                    wTrillions := isum mod 1000;
                 end
              end
           end
        end
     except
           on EInvalidOp do begin
           // probably user passed sum is not within the Longint range
           s := FormatFloat('000000000000000', sum);
           wRubles := 100 * char_to_digit(s[13]) + 10 * char_to_digit(s[14]) +
                   char_to_digit(s[15]);
           if sum > 1.0e3 - 1.0 then begin
              wThousands := 100 * char_to_digit(s[10]) + 10 * char_to_digit(s[11]) + char_to_digit(s[12]);
              if sum > 1.0e6 - 1.0 then begin
                 wMillions := 100 * char_to_digit(s[7]) + 10 * char_to_digit(s[8]) + char_to_digit(s[9]);
                 if sum > 1.0e9 - 1.0 then begin
                    wBillions := 100 * char_to_digit(s[4]) + 10 * char_to_digit(s[5]) + char_to_digit(s[6]);
                    if sum > 1.0e12 - 1.0 then begin
                       wTrillions := 100 * char_to_digit(s[1]) + 10 * char_to_digit(s[2]) + char_to_digit(s[3]);
                    end
                 end
              end
           end
        end
     end
end;

function power_to_gender(aPwr : Power) : Gender;
begin
  case aPwr of
    Rubles, Millions, Billions, Trillions : Result := Masculine;
    Thousands : Result := Feminine;
    else
        // Won't happen. (to shut up compiler)
        Result := Masculine;
  end;
end;

function get_currency(digit1, digit2 : Byte; aPwr: Power; aVal : Word) : String;
var i : Longint;
begin

  if digit2 = 1 then i:=0
    else i := digit1;

  if aPwr = Rubles then begin
    case aVal of
      0 :
      Result := '';
      1 :
      Result := '.';
      2 :
      case i of
           0,5..9 : Result := '';
           2..4 : Result := '';
           1 : Result := '';
      end;
    end;
  end else if aPwr = Copecks then begin
    case aVal of
      0 : Result := '';
      1, 3 : Result := '.';
      2, 4 : case i of
          0,5..9 : Result := '';
          2..4 : Result := '';
          1 : Result := '';
        end;
    end;
  end else
    case aVal of
      1 :
      case aPwr of
          Thousands : Result := '.';
          Millions : Result := '.';
          Billions : Result := '.';
          Trillions : Result := '.';
      end;
      2 :
      case aPwr of
          Thousands :
          case i of
               0,5..9 : Result := '';
               2..4 : Result := '';
               1 : Result := '';
          end;
          Millions :
          case i of
               0,5..9 : Result := '';
               2..4 : Result := '';
               1 : Result := '';
          end;
          Billions :
          case i of
               0,5..9 : Result := '';
               2..4 : Result := '';
               1 : Result := '';
          end;
          Trillions :
          case i of
               0,5..9 : Result := '';
               2..4 : Result := '';
               1 : Result := '';
          end;
      end;
  end;
end;

function triada_with_currency_to_str(triada : Word; aPwr: Power; aVal : Word) : String;
var digit1, digit2 : Byte;
begin
    Result := triada_to_str(triada, power_to_gender(aPwr));
    digit1 := triada mod 10;
    triada := triada div 10;
    digit2 := triada mod 10;
    Result := Result + ' ' + get_currency(digit1, digit2, aPwr, aVal);
end;

function delphi_num_to_rub(f : Double; aCopecks, aRubles, aPowers : Longint):String ;
var wRubles, wThousands, wMillions, wBillions, wTrillions, wCopecks : Word;
    digit1, digit2, digit3 : Byte;
    tmp : String;
    tmpF : Double;
    negative : Boolean;
begin
try
   if f < 0 then begin
      negative := true;
      f := -f;
   end else begin
      negative := false
   end;

   split_sum(f, wCopecks, wRubles, wThousands, wMillions, wBillions, wTrillions);
   Result:='';
   if wTrillions > 0 then Result := triada_with_currency_to_str(wTrillions,
      Trillions, aPowers) + ' ';
   if wBillions > 0 then Result := Result + triada_with_currency_to_str(wBillions,
      Billions, aPowers) + ' ';
   if wMillions > 0 then Result := Result + triada_with_currency_to_str(wMillions,
      Millions, aPowers) + ' ';
   if wThousands > 0 then Result := Result + triada_with_currency_to_str(wThousands,
      Thousands, aPowers) + ' ';
   if wRubles > 0 then begin
      Result := Result + triada_with_currency_to_str(wRubles,
             Rubles, aRubles) + ' ';
   end else begin
       if Length(Result) = 0 then begin
          case aRubles of
               0 : Result := '';
               1 : Result := ' .';
               2 : Result := ' ';
          end;
       end else case aRubles of
            1 : Result := Result + '.';
            2 : Result := Result + '';
       end;
   end;

  if aCopecks > 0 then begin
     split_triada(wCopecks, digit1, digit2, digit3);
     case aCopecks of
          1, 2:
          Result := TrimRight(Result) + ' ' +
                 decoded_diada_to_str(digit1, digit2, Feminine, false);
          3, 4: begin
          Result := TrimRight(Result) + ' ' +
                 digit_to_char(digit2) + digit_to_char(digit1);
          end
     end;
     Result := Result + ' ' +
           get_currency(digit1, digit2, Copecks, aCopecks);
  end;

  if negative then begin
     Result := '(' + Result + ')';
  end
except
      Result := '';
end;
end;

procedure num_to_rub(f : Double; aCopecks, aRubles, aPowers : Longint; P : PChar);
begin
   StrPCopy(P, delphi_num_to_rub(f, aCopecks, aRubles, aPowers));
end;

end.
