unit tester;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Buttons;

type
  TForm1 = class(TForm)
    Edit: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    ComboCop: TComboBox;
    ComboPwr: TComboBox;
    ComboRub: TComboBox;
    Memo: TMemo;
    MemoResults: TMemo;
    ResultLabel: TLabel;
    Bevel1: TBevel;
    Write: TSpeedButton;
    SpeedButton: TSpeedButton;
    Label4: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure WriteClick(Sender: TObject);
    procedure SpeedButtonClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;
var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure num_to_rub(f : Double; aCopecks, aRubles, aPowers : Longint; result : PChar);
         stdcall; external 'NumToRub.dll' name 'num_to_rub';


procedure TForm1.FormCreate(Sender: TObject);
begin
    ComboCop.ItemIndex := 1;
    ComboPwr.ItemIndex := 1;
    ComboRub.ItemIndex := 1;
    with MemoResults.Lines do begin
       Add('  :    ');
       Add('');
       Add('Intel Pentium 150 ( MMX): 13.3');
       Add('Intel Pentium II 400: 36.1');
       Add('AMD K6-2 400: 36.3');
    end;
    Edit.Text := '9876543,21';
end;

procedure TForm1.WriteClick(Sender: TObject);
var
   sum : Double;
   s : String;
   Cop, Rub, Pwr : Integer;
   P : PChar;
begin
     with ComboCop do begin
          if Text = ' (0)' then
             Cop := 0
          else if Text = ' (1)' then
               Cop := 1
          else if Text = ' (2)' then
               Cop := 2
          else if Text = '  (3)' then
               Cop := 3
          else if Text = '  (4)' then
               Cop := 4;
     end;

     with ComboRub do begin
          if Text = ' (0)' then
             Rub := 0
          else if Text = ' (1)' then
               Rub := 1
          else if Text = ' (2)' then
               Rub := 2;
     end;

     with ComboPwr do begin
          if Text = ' (0)' then
             Pwr := 0
          else if Text = ' (1)' then
               Pwr := 1
          else if Text = ' (2)' then
               Pwr := 2;
     end;

     P := nil;

     try try
        sum := StrToFloat(Edit.Text);
        GetMem(P, 1000);
        num_to_rub(sum, Cop, Rub, Pwr, P);
        Memo.Text := P;
     except
           on EConvertError do begin
              Application.MessageBox('     ', '', IDOK);
           end
     end
     finally
            FreeMem(P);
     end
end;

procedure TForm1.SpeedButtonClick(Sender: TObject);
var
   i : Longint;
   date1, date2 : TDateTime;
   NTRS : Double;
   msg : String;
   P : PChar;
begin
     GetMem(P, 1000);
     try
        MemoResults.Enabled := false;
        SpeedButton.Enabled := false;
        Application.HandleMessage();
        Application.ProcessMessages();
        date1 := Time();
        for i := 1 to 1000000 do  begin
            num_to_rub(i, 2, 2, 2, P);
        end;
        date2 := Time();
        NTRS := 1000.0 / ((date2 - date1) * 3600.0 * 24.0);
        msg := ' : ' + FormatFloat('#.00', NTRS);
        MemoResults.Hint := '     ' + #13#10 +
                         '        ' + #13#10 +
                         '      e-mail: num2rub@hotmail.com';
        MemoResults.ShowHint := true;
        SpeedButton.Hint := MemoResults.Hint;
        SpeedButton.ShowHint := MemoResults.ShowHint;

        MemoResults.Lines.Add(msg);
        MemoResults.Enabled := true;
        SpeedButton.Enabled := true;
     finally
        FreeMem(P);
     end;
end;

end.
